"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const qpqAwsLambdaRuntimeConfigUtils_1 = require("../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils");
const getParameter_1 = require("../../../logic/parametersManager/getParameter");
const getProcessConfigGetParameter = (qpqConfig) => {
    return ({ parameterName }) => __awaiter(void 0, void 0, void 0, function* () {
        const awsParameterKey = (0, qpqAwsLambdaRuntimeConfigUtils_1.resolveParameterKey)(parameterName, qpqConfig);
        const parameterValue = yield (0, getParameter_1.getParameter)(awsParameterKey, quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig));
        return (0, quidproquo_core_1.actionResult)(parameterValue);
    });
};
exports.default = (qpqConfig) => {
    return {
        [quidproquo_core_1.ConfigActionType.GetParameter]: getProcessConfigGetParameter(qpqConfig),
    };
};
