import { QPQConfig, MatchStoryResult, EventMatchStoryActionProcessor, EventTransformEventParamsActionProcessor, EventTransformResponseResultActionProcessor, EventAutoRespondActionProcessor } from 'quidproquo-core';
import { SeoQPQWebServerConfigSetting, SeoEvent, SeoEventResponse, SeoEventRouteParams } from 'quidproquo-webserver';
import { CloudFrontRequestEvent, Context } from 'aws-lambda';
export type CloudFrontOriginMatchStoryResult = MatchStoryResult<SeoEventRouteParams, SeoQPQWebServerConfigSetting>;
declare const _default: (config: QPQConfig) => {
    "@quidproquo-core/event/TransformEventParams": EventTransformEventParamsActionProcessor<[CloudFrontRequestEvent, Context], SeoEvent<any>>;
    "@quidproquo-core/event/TransformResponseResult": EventTransformResponseResultActionProcessor<SeoEventResponse, SeoEvent<any>, SeoEventResponse>;
    "@quidproquo-core/event/AutoRespond": EventAutoRespondActionProcessor<SeoEvent<any>, CloudFrontOriginMatchStoryResult, null>;
    "@quidproquo-core/event/MatchStory": EventMatchStoryActionProcessor<SeoEvent<any>, CloudFrontOriginMatchStoryResult>;
};
export default _default;
