"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const getProcessTransformEventParams = () => {
    return ({ eventParams: [eventBridgeEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        return (0, quidproquo_core_1.actionResult)({
            time: eventBridgeEvent.time,
            correlation: context.awsRequestId,
            detail: eventBridgeEvent.detail,
        });
    });
};
// No transform
const getProcessTransformResponseResult = () => {
    return ({ response }) => __awaiter(void 0, void 0, void 0, function* () { return (0, quidproquo_core_1.actionResult)(response); });
};
// never early exit (maybe add validation?)
const getProcessAutoRespond = () => {
    return () => __awaiter(void 0, void 0, void 0, function* () { return (0, quidproquo_core_1.actionResult)(null); });
};
const getProcessMatchStory = (lambdaRuntimeConfig) => {
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        if (!lambdaRuntimeConfig) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, 'event runtime not found');
        }
        return (0, quidproquo_core_1.actionResult)({
            src: lambdaRuntimeConfig.src,
            runtime: lambdaRuntimeConfig.runtime,
            runtimeOptions: {},
        });
    });
};
exports.default = (runtimeConfig) => {
    return {
        [quidproquo_core_1.EventActionType.TransformEventParams]: getProcessTransformEventParams(),
        [quidproquo_core_1.EventActionType.TransformResponseResult]: getProcessTransformResponseResult(),
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(),
        [quidproquo_core_1.EventActionType.MatchStory]: getProcessMatchStory(runtimeConfig),
    };
};
