import { QPQConfig, MatchStoryResult, EventMatchStoryActionProcessor, EventTransformEventParamsActionProcessor, EventTransformResponseResultActionProcessor, EventAutoRespondActionProcessor, QueueMessage, QueueQPQConfigSetting } from 'quidproquo-core';
import { QueueEvent, QueueEventTypeParams } from 'quidproquo-webserver';
import { Context, SQSRecord } from 'aws-lambda';
type AnyQueueEvent = QueueEvent<QueueMessage<any>>;
export type SqsEventMatchStoryResult = MatchStoryResult<QueueEventTypeParams, string>;
export declare const getQueueConfigSetting: () => QueueQPQConfigSetting;
declare const _default: (qpqConfig: QPQConfig) => {
    "@quidproquo-core/event/TransformEventParams": EventTransformEventParamsActionProcessor<[SQSRecord, Context], AnyQueueEvent>;
    "@quidproquo-core/event/TransformResponseResult": EventTransformResponseResultActionProcessor<boolean, AnyQueueEvent, boolean>;
    "@quidproquo-core/event/AutoRespond": EventAutoRespondActionProcessor<AnyQueueEvent, SqsEventMatchStoryResult, boolean>;
    "@quidproquo-core/event/MatchStory": EventMatchStoryActionProcessor<AnyQueueEvent, SqsEventMatchStoryResult>;
};
export default _default;
