"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDateNow = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsLambdaUtils_1 = require("./../../../awsLambdaUtils");
const getDateNow = () => new Date().toISOString();
exports.getDateNow = getDateNow;
const getProcessExecuteStory = (dynamicModuleLoader) => {
    return (payload, session, actionProcessors) => __awaiter(void 0, void 0, void 0, function* () {
        let module = yield dynamicModuleLoader(payload.src);
        if (module === null) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Module not found [${payload.src}]`);
        }
        const story = module[payload.runtime];
        if (!story) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `[${payload.runtime}] not found in module [${payload.src}]`);
        }
        const logger = (result) => __awaiter(void 0, void 0, void 0, function* () {
            // return await addResult(service, getDateNow(), payload.params[0][0].path, 'user-route', payload.src, payload.runtime, result);
        });
        const resolveStory = (0, quidproquo_core_1.createRuntime)(session, actionProcessors, exports.getDateNow, logger, awsLambdaUtils_1.randomGuid);
        const storyResult = yield resolveStory(story, payload.params);
        if (storyResult.error) {
            return (0, quidproquo_core_1.actionResultError)(storyResult.error.errorType, `story error! in ${payload.src}::${payload.runtime} -> [${storyResult.error.errorText}]`, storyResult.error.errorStack);
        }
        return (0, quidproquo_core_1.actionResult)(storyResult.result);
    });
};
exports.default = (dynamicModuleLoader) => {
    return {
        [quidproquo_core_1.SystemActionType.ExecuteStory]: getProcessExecuteStory(dynamicModuleLoader),
    };
};
