"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createUser = void 0;
const client_cognito_identity_provider_1 = require("@aws-sdk/client-cognito-identity-provider");
const createUser = (userPoolId, region, createUserRequest) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const cognitoClient = new client_cognito_identity_provider_1.CognitoIdentityProviderClient({ region });
    const params = {
        UserPoolId: userPoolId,
        Username: createUserRequest.email,
        MessageAction: client_cognito_identity_provider_1.MessageActionType.SUPPRESS,
        DesiredDeliveryMediums: [client_cognito_identity_provider_1.DeliveryMediumType.EMAIL],
        UserAttributes: [{ Name: 'email', Value: createUserRequest.email }],
        ForceAliasCreation: false,
    };
    if (createUserRequest.phone) {
        params.DesiredDeliveryMediums.push(client_cognito_identity_provider_1.DeliveryMediumType.SMS);
        params.UserAttributes.push({ Name: 'phone_number', Value: createUserRequest.phone });
    }
    const response = yield cognitoClient.send(new client_cognito_identity_provider_1.AdminCreateUserCommand(params));
    const username = ((_a = response.User) === null || _a === void 0 ? void 0 : _a.Username) || '';
    // There has to be a better way than this?
    const passwordParams = {
        Password: createUserRequest.password,
        Username: username,
        UserPoolId: userPoolId,
        Permanent: true,
    };
    yield cognitoClient.send(new client_cognito_identity_provider_1.AdminSetUserPasswordCommand(passwordParams));
    // ///////////////////////
    return username;
});
exports.createUser = createUser;
